CollectAtMissions = {};

-- Wird aufgerufen, wenn die Karte geladen wird
function CollectAtMissions:loadMap(name)
    -- Überschreibt die Funktion getIsMissionWorkAllowed im MissionManager
    MissionManager.getIsMissionWorkAllowed = Utils.overwrittenFunction(
        MissionManager.getIsMissionWorkAllowed,
        CollectAtMissions.getIsMissionWorkAllowed
    );

    -- Optional: Debug-Ausgabe
    print("CollectAtMissions: Mod erfolgreich geladen!");
end;

-- Erweiterte Logik für das Zulassen von Arbeiten während Missionen
function CollectAtMissions:getIsMissionWorkAllowed(superFunc, farmId, x, z, workAreaType)
    -- Standardüberprüfung
    local isAllowed = superFunc(self, farmId, x, z, workAreaType);

    -- Zusätzliche Logik für das Zulassen von Arbeiten während Missionen
    if not isAllowed then
        -- Prüfe, ob der Arbeitsbereich zu einer Mission gehört und ob der Arbeitstyp erlaubt ist
        local mission = g_missionManager:getMissionAtWorldPosition(x, z);

        if mission and mission.farmId == farmId then
            -- Erlaubte Arbeitstypen während Missionen
            if workAreaType == WorkAreaType.FORAGEWAGON    -- Ladewagen
            or workAreaType == WorkAreaType.BALER         -- Ballenpressen
            or workAreaType == WorkAreaType.PELLETIZER    -- Pelletierer
            or workAreaType == WorkAreaType.MOWER         -- Gras
            or workAreaType == WorkAreaType.STONEPICKER   -- Steinsammler
            then
                return true;
            end
        end
    end

    return isAllowed;
end;

-- Registriert das Skript als Mod-Event-Listener
addModEventListener(CollectAtMissions);
